import 'package:excel/excel.dart';
import 'package:file_picker/file_picker.dart';

class ExcelToMap {
  Future<Map<String, List<Map<String, dynamic>>>?> pick() async {
    FilePickerResult? file = await FilePicker.platform.pickFiles(
        type: FileType.custom, allowedExtensions: ['xlsx', 'csv', 'xls']);

    if (file == null || file.files.isEmpty || file.files.first.bytes == null) {
      return null;
    }
    var excel = Excel.decodeBytes(file.files.first.bytes!);
    Map<String, List<Map<String, dynamic>>> json = {};
    for (var table in excel.tables.keys) {
      final List<List<Data?>> rows = excel.tables[table]?.rows ?? [];

      List<dynamic> keys = <dynamic>[];
      List<Map<String, dynamic>> jsonData = <Map<String, dynamic>>[];
      for (var i = 0; i < rows.length; i++) {
        final currentRow = rows[i];
        if (i == 0) {
          keys = currentRow.map((e) => e?.value.toString()).toList();
        } else {
          Map<String, dynamic> temp = <String, dynamic>{};
          for (var j = 0; j < currentRow.length; j++) {
            if (keys[j] == null) {
              continue;
            }

            if (currentRow[j]?.stringify != null && currentRow[j]!.stringify!) {
              temp[keys[j]] = currentRow[j]?.value.toString();
            } else {
              temp[keys[j]] = currentRow[j]?.value;
            }
          }
          jsonData.add(temp);
        }
      }
      json[table] = jsonData;
    }

    return json;
  }
}
