int? formattedDateToMilliseconds({
  required String date,
}) {
  if (!isFormattedDate(date: date)) {
    return null;
  }

  final split = date.split('/');
  int day = int.parse(split.first);
  int month = int.parse(split[1]);
  int year =
      split[2].length == 2 ? int.parse("20${split[2]}") : int.parse(split[2]);

  return DateTime(
    year,
    month,
    day,
  ).millisecondsSinceEpoch;
}

bool isFormattedDate({
  required String date,
}) {
  final split = date.split('/');
  if (split.length == 3 &&
      (split[0].length == 1 || split[0].length == 2) &&
      int.tryParse(split[0]) != null &&
      int.parse(split[0]) >= 1 &&
      int.parse(split[0]) <= 31 &&
      (split[1].length == 1 || split[1].length == 2) &&
      int.tryParse(split[1]) != null &&
      int.parse(split[1]) >= 1 &&
      int.parse(split[1]) <= 12 &&
      (split[2].length == 2 || split[2].length == 4) &&
      int.tryParse(split[2]) != null) {
    return true;
  }
  return false;
}
