import 'package:verttice_models/verttice_models.dart';

isPhoneNumber({
  required String phone,
  required CountryFF country,
}) {
  if (int.tryParse(phone) != null &&
      phone.length >= country.minLength &&
      phone.length <= country.maxLength) {
    return true;
  }
  return false;
}

/// the pattern should be 01234567,012342434,12343243 etc.
List<PhoneNumberModel>? textToPhoneNumbers({
  required String text,
}) {
  final country = countriesFF.firstWhere((element) => element.code == 'GB');

  final stringPhoneNumber = text
      .replaceAll(' ', '')
      .split(text.contains(',') ? ',' : '/')
      .map((e) => e.startsWith('0') ? e.replaceFirst('0', '') : e)
      .where((element) {
    return isPhoneNumber(phone: element, country: country);
  }).toList();
  final phoneNumbers = stringPhoneNumber
      .map(
        (e) => PhoneNumberModel(
          countryCode: country.code,
          flag: country.flag,
          number: "${country.dialCode}$e",
          prettyNumber: "0$e",
        ),
      )
      .toList();

  return phoneNumbers;
}

/// the pattern should be 123234354 or 0423423432
PhoneNumberModel? textToPhoneNumber({
  required String text,
}) {
  final country = countriesFF.firstWhere((element) => element.code == 'GB');

  text = text.replaceAll(' ', '');
  if (!isPhoneNumber(phone: text, country: country)) {
    return null;
  }
  text = text.startsWith('0') ? text.replaceFirst('0', '') : text;
  return PhoneNumberModel(
    countryCode: country.code,
    flag: country.flag,
    number: "${country.dialCode}$text",
    prettyNumber: "0$text",
  );
}
