// 🐦 Flutter imports:
import "package:flutter/material.dart";

// 🌎 Project imports:
import 'package:verttice_ui/verttice_ui.dart';

Future<void> actionsDialog({
  required BuildContext context,
  required String content,
  required List<Widget> Function(BuildContext context) actionsBuilder,
  bool barrierDismissible = true,
  String? title,
}) async {
  return await showDialog<void>(
    context: context,
    useSafeArea: true,
    barrierDismissible: barrierDismissible,
    builder: (BuildContext context) {
      return AlertDialog(
        title: ThemedAppBar(
          title: title,
          navigateBackButton: true,
        ),
        content: Text(
          content,
        ),
        actions: actionsBuilder(context)
            .map(
              (e) => const Padding(
                padding: EdgeInsets.symmetric(horizontal: 2),
              ),
            )
            .toList(),
      );
    },
  );
}
