// 🐦 Flutter imports:
import "package:flutter/material.dart";

// 🌎 Project imports:
import 'package:verttice_ui/verttice_ui.dart';

Future<bool?> confirmDialog({
  required BuildContext context,
  required String content,
  String? title,
  bool barrierDismissible = true,
}) async {
  return await showDialog<bool?>(
    context: context,
    useSafeArea: true,
    barrierDismissible: barrierDismissible,
    builder: (BuildContext context) {
      return AlertDialog(
        title: title != null
            ? Text(
                title,
              )
            : null,
        content: Padding(
          padding: const EdgeInsets.all(12.0),
          child: Text(
            content,
          ),
        ),
        actions: [
          SizedBox(
            width: 70,
            child: ThemedTextButton(
              'Yes',
              textStyle: const TextStyle(
                color: Colors.white,
              ),
              color: Colors.red,
              onPressed: (() => Navigator.of(context).pop(true)),
            ),
          ),
          sizedBoxW4,
          SizedBox(
            width: 70,
            child: ThemedTextButton(
              'Cancel',
              textStyle: const TextStyle(
                color: Colors.white,
              ),
              color: Colors.lightBlue,
              onPressed: (() => Navigator.of(context).pop(false)),
            ),
          ),
        ],
      );
    },
  );
}
