// 🐦 Flutter imports:
import "package:flutter/material.dart";

// 🌎 Project imports:
import 'package:verttice_ui/verttice_ui.dart';

Future<void> infoDialog({
  required BuildContext context,
  required String content,
  String? textButton,
  bool barrierDismissible = true,
}) async {
  return await showDialog<void>(
    context: context,
    useSafeArea: true,
    barrierDismissible: barrierDismissible,
    builder: (BuildContext context) {
      return AlertDialog(
        content: Text(
          content,
        ),
        actions: [
          SizedBox(
            width: 70,
            child: ThemedTextButton(
              textButton ?? 'GOT IT',
              textStyle: const TextStyle(
                color: Colors.white,
              ),
              color: Colors.lightBlue,
              onPressed: (() => Navigator.of(context).pop()),
            ),
          ),
        ],
      );
    },
  );
}
