// 🐦 Flutter imports:
import "package:flutter/material.dart";

class FadeEdges extends StatelessWidget {
  final Widget child;
  final Axis fadeDirection;
  const FadeEdges({
    Key? key,
    required this.child,
    this.fadeDirection = Axis.horizontal,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return ShaderMask(
      shaderCallback: (Rect bounds) {
        return LinearGradient(
          begin: fadeDirection == Axis.vertical
              ? Alignment.topCenter
              : Alignment.centerLeft,
          end: fadeDirection == Axis.vertical
              ? Alignment.bottomCenter
              : Alignment.centerRight,
          colors: fadeDirection == Axis.vertical
              ? <Color>[
                  Colors.purple,
                  Colors.transparent,
                  Colors.transparent,
                  Colors.purple
                ]
              : <Color>[
                  Colors.transparent,
                  Colors.purple,
                  Colors.purple,
                  Colors.transparent,
                ],
          stops: fadeDirection == Axis.vertical
              ? [0.0, 0.1, 0.9, 1.0]
              : [0.0, 0.08, 0.9, 1.0],
        ).createShader(bounds);
      },
      blendMode:
          fadeDirection == Axis.vertical ? BlendMode.dstOut : BlendMode.dstIn,
      child: child,
    );
  }
}
