// 🐦 Flutter imports:
import "package:flutter/material.dart";

// 📦 Package imports:
import 'package:verttice_models/verttice_models.dart';

// 🌎 Project imports:
import "package:verttice_ui/src/const/box_sizes.dart";
import 'package:verttice_ui/src/widgets/files/file_list_view.dart';
import 'package:verttice_ui/src/widgets/files/upload_file.dart';

class FileUploadAndViewNetwork extends StatelessWidget {
  final List<FileModel>? files;
  final Function(FileModel)? deleteFileCallback;
  final Future<void> Function({
    required List<FileModel> files,
  }) filesDataCallback;
  final String path;
  final String? buttonText;
  final bool multi;
  final VoidCallback? onDoneUpload;

  const FileUploadAndViewNetwork({
    Key? key,
    required this.path,
    required this.filesDataCallback,
    this.files,
    this.deleteFileCallback,
    this.buttonText,
    this.multi = true,
    this.onDoneUpload,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return SizedBox(
      child: Column(
        children: [
          if (files != null && files!.isNotEmpty)
            FileListView(
              fromStorage: false,
              deleteFileCallback: deleteFileCallback,
              files: files ?? [],
            ),
          sizedBoxH4,
          UploadFile(
            multi: multi,
            buttonText: buttonText,
            filesDataCallback: filesDataCallback,
            path: path,
            onDoneUpload: onDoneUpload,
          ),
        ],
      ),
    );
  }
}
