// 🐦 Flutter imports:
import "package:flutter/material.dart";

// 🌎 Project imports:
import 'package:verttice_ui/src/widgets/themed_widgets/themed_widgets_index.dart';

class MenuButton extends StatelessWidget {
  final BuildContext context;
  final String text;

  final Widget widget;

  const MenuButton({
    Key? key,
    required this.context,
    required this.text,
    required this.widget,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Center(
      child: Padding(
        padding: const EdgeInsets.fromLTRB(30, 10, 30, 10),
        child: ThemedTextButton(
          text,
          onPressed: () {
            Navigator.push(
                context, MaterialPageRoute(builder: (context) => widget));
          },
        ),
      ),
    );
  }
}
