// 🐦 Flutter imports:
import "package:flutter/material.dart";

class NavigatorPage extends StatefulWidget {
  final Widget? child;
  final GlobalKey? navigatorKey;

  const NavigatorPage({
    Key? key,
    required this.navigatorKey,
    required this.child,
  }) : super(key: key);

  @override
  State<NavigatorPage> createState() => _NavigatorPageState();
}

class _NavigatorPageState extends State<NavigatorPage> {
  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Navigator(
      key: widget.navigatorKey,
      onGenerateRoute: (RouteSettings settings) {
        return MaterialPageRoute(
          settings: settings,
          builder: (BuildContext context) {
            return Scaffold(
              body: widget.child,
            );
          },
        );
      },
    );
  }
}
