// 🐦 Flutter imports:
import 'package:flutter/material.dart';

// 🌎 Project imports:
import 'package:verttice_ui/verttice_ui.dart';

class ThemedCleanTextButton extends StatelessWidget {
  final String text;
  final Icon? icon;
  final VoidCallback onPressed;
  final TextStyle? textStyle;
  final WrapAlignment iconButtonAligmnet;
  const ThemedCleanTextButton(
    this.text, {
    Key? key,
    this.icon,
    this.textStyle,
    this.iconButtonAligmnet = WrapAlignment.start,
    required this.onPressed,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    if (icon != null) {
      return TextButton.icon(
        onPressed: onPressed,
        label: Text(
          text,
          style: ThemedFonts.primary().merge(textStyle),
          // softWrap: true,
          overflow: TextOverflow.ellipsis,
        ),
        icon: Icon(icon!.icon!, size: icon!.size ?? 20),
      );
    }

    return TextButton(
      onPressed: onPressed,
      child: Text(
        text,
        style: ThemedFonts.primary().merge(textStyle),
        overflow: TextOverflow.ellipsis,
      ),
    );
  }
}
