// 🐦 Flutter imports:
import "package:flutter/material.dart";

// 📦 Package imports:
import 'package:provider/provider.dart';

// 🌎 Project imports:
import 'package:verttice_ui/src/state/verttice_ui_state.dart';

class ThemedDivider extends StatefulWidget {
  final double? height;
  final double? width;
  final EdgeInsets? padding;

  const ThemedDivider({
    Key? key,
    this.height,
    this.width,
    this.padding,
  }) : super(key: key);
  @override
  State<ThemedDivider> createState() => _ThemedDividertate();
}

class _ThemedDividertate extends State<ThemedDivider> {
  @override
  Widget build(BuildContext context) {
    return Consumer<VertticeUIState>(builder: (context, value, _) {
      return Container(
          padding: widget.padding,
          width: widget.width,
          height: widget.height,
          decoration: BoxDecoration(
            color: value.themedColors.accentColor,
            boxShadow: [
              BoxShadow(
                color: Colors.grey[300]!,
                blurRadius: 1.0,
                offset: const Offset(1.0, 1.0),
              )
            ],
          ));
    });
  }
}
