// 🐦 Flutter imports:
import 'package:flutter/material.dart';

// 📦 Package imports:
import 'package:fluent_ui/fluent_ui.dart' as fluent;
import 'package:provider/provider.dart';

// 🌎 Project imports:
import 'package:verttice_ui/verttice_ui.dart';

class ThemedIconButton extends StatelessWidget {
  final VoidCallback onPressed;
  final Icon icon;
  final bool? isOffMode;
  final String? tooltip;
  const ThemedIconButton({
    Key? key,
    required this.onPressed,
    required this.icon,
    this.isOffMode,
    this.tooltip,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Consumer<VertticeUIState>(builder: (
      BuildContext context,
      VertticeUIState value,
      Widget? _,
    ) {
      return Tooltip(
        message: tooltip ?? '',
        showDuration: Duration(milliseconds: tooltip == null ? 0 : 1500),
        child: FittedBox(
          fit: BoxFit.scaleDown,
          child: fluent.IconButton(
            onPressed: isOffMode != null && isOffMode! ? () {} : onPressed,
            icon: Icon(
              icon.icon,
              size: icon.size ?? 20,
              color: isOffMode != null && isOffMode!
                  ? Colors.grey
                  : (icon.color ?? value.themedColors.accentColor),
            ),
          ),
        ),
      );
    });
  }
}
