import 'package:flutter/material.dart';
import 'package:verttice_ui/verttice_ui.dart';

class ThemedResponsiveAction {
  final VoidCallback onPressed;
  final String label;

  ThemedResponsiveAction({
    required this.onPressed,
    required this.label,
  });
}

class ThemedResponsiveActions extends StatefulWidget {
  final List<ThemedResponsiveAction> actions;

  const ThemedResponsiveActions({
    Key? key,
    required this.actions,
  }) : super(key: key);

  @override
  State<ThemedResponsiveActions> createState() =>
      _ThemedResponsiveActionsState();
}

class _ThemedResponsiveActionsState extends State<ThemedResponsiveActions> {
  @override
  Widget build(BuildContext context) {
    return ScreenHandler(
      desktopWidget: Row(
        children: widget.actions
            .map(
              (e) => Padding(
                padding: const EdgeInsets.symmetric(horizontal: 2),
                child: ThemedCleanTextButton(e.label, onPressed: e.onPressed),
              ),
            )
            .toList(),
      ),
      mobileWidget: Align(
        alignment: Alignment.centerRight,
        child: SizedBox(
          width: 50,
          child: PopupMenuButton(
            child: ThemedIcons.more(),
            itemBuilder: (BuildContext context) {
              return widget.actions
                  .map(
                    (action) => PopupMenuItem(
                      padding: const EdgeInsets.all(2),
                      onTap: action.onPressed,
                      child: Text(action.label),
                    ),
                  )
                  .toList();
            },
          ),
        ),
      ),
    );
  }
}
