// 🐦 Flutter imports:
import 'package:flutter/material.dart';

class ThemedWillPop extends StatelessWidget {
  final Widget child;
  final bool navigateBackButton;
  final bool areYouSurePopup;
  final String areYouSureText;
  final Future<void> Function()? onPop;

  const ThemedWillPop({
    Key? key,
    required this.child,
    this.navigateBackButton = true,
    this.areYouSurePopup = false,
    this.areYouSureText =
        "Are you sure you want to exit this page. chnages will discard?",
    this.onPop,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return WillPopScope(
      child: child,
      onWillPop: () async {
        if (!navigateBackButton) {
          return false;
        } else {
          if (areYouSurePopup) {
            final value = await showDialog<bool>(
              context: context,
              builder: (context) {
                return AlertDialog(
                  content: SelectableText(
                    areYouSureText,
                    style: const TextStyle(
                      color: Colors.redAccent,
                    ),
                  ),
                  actions: <Widget>[
                    TextButton(
                      child: const Text(
                        "No",
                        style: TextStyle(color: Colors.blue),
                      ),
                      onPressed: () {
                        return Navigator.of(context).pop(false);
                      },
                    ),
                    TextButton(
                      child: const Text(
                        "Yes, exit anyway",
                        style: TextStyle(color: Colors.red),
                      ),
                      onPressed: () async {
                        if (onPop != null) {
                          await onPop!();
                        }

                        return Navigator.of(context).pop(true);
                      },
                    ),
                  ],
                );
              },
            );
            return value == true;
          } else {
            if (onPop != null) {
              await onPop!();
            }
            return true;
          }
        }
      },
    );
  }
}
